/** 
 * This program is free software: you can redistribute it and/or modify it under the terms of the
 * GNU Affero General Public License as published by the Free Software Foundation, either version 3
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without
 * even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 * Affero General Public License for more details.
 * 
 * You should have received a copy of the GNU Affero General Public License along with this program.
 * If not, see http://www.gnu.org/licenses/.
*/
package com.owc.singularity.engine.object;


import com.owc.singularity.engine.metadata.transformer.ExampleSetMetaDataTransformer;
import com.owc.singularity.engine.object.data.exampleset.ExampleSetHeader;
import com.owc.singularity.engine.object.data.exampleset.ExampleSetTransformer;
import com.owc.singularity.engine.operator.error.OperatorException;
import com.owc.singularity.engine.operator.error.UserError;


/**
 * Model is the interface for all objects which change a data set. For example, a model generated by
 * a learner might add a predicted attribute. Other models can be created during preprocessing, e.g.
 * a transformation model containing the parameters for a z-transformation. Models can be combined
 * by using a CompositeModel. Please note that all models will automatically be wrapped into a
 * ContainerModel if they are not already part of it. All models can be applied with a ModelApply
 * operator.
 * 
 * @author Ingo Mierswa
 */
public interface Model extends IOObject, Readable {

    /**
     * This method has to return the {@link ExampleSetHeader} containing the signature of the
     * example set during training time containing all information about attributes. This is
     * important for checking the compatibility of the examples on application time. Note that the
     * AbstractModel already implements all necessary functionality.
     */
    public ExampleSetHeader getTrainingHeader();

    /**
     * Applies the model by adding respective transformations on the given transformer. The
     * applySetHeader allows to check whether this model is actually compatible. Otherwise an
     * {@link OperatorException} must be thrown. The header can also be used to determine types of
     * transformation, etc.
     */
    public ExampleSetTransformer apply(ExampleSetHeader applySetHeader, ExampleSetTransformer transformer) throws OperatorException;

    /**
     * This method can be called before {@link #apply(ExampleSetHeader, ExampleSetTransformer)} the
     * model onto an example set to verify whether it is compatible.
     * 
     * @param applySetHeader
     *            The header of the example set that will be applied
     * @throws UserError
     *             thrown if the given set doesn't match the training header according to this
     *             models requirements.
     */
    public void checkCompatibility(ExampleSetHeader applySetHeader) throws UserError;

    public ExampleSetMetaDataTransformer getApplicationMetaDataTransformer();

    public ExampleSetHeader.TrainingSetRelation getAllowedSetRelation();
}
